# Contributing

Thank you for your interest in this project! We want to encourage individuals and organisations to be involved in its ongoing development as users and contributors.

## Issues

We welcome bug reports and feature requests for the implementation. These should be submitted as Issues on GitHub:

- [Sign up](https://github.com/join) for GitHub if you haven't already done so.
- Check whether someone has already submitted a similar Issue.
- If necessary, submit a new Issue.

Good bug reports will include a clear title and description, as much relevant information as possible, and preferably a code sample or an executable test case demonstrating the expected behavior that is not occurring.

## Pull Requests

You can submit bug fixes, patches and other improvements to the code or documentation for review through a GitHub pull request as follows:

* Fork the repository.
* Make and commit changes.
* Push your changes to a topic branch in your fork.
* Make sure you understand how the repository licence applies to pull requests (see below).
* Submit a pull request.

Good PRs will include a clear rationale for the patch, and should follow the style of the existing code or documentation in this area.

## Licence Agreement

To make the process of contributing as simple as possible, we do not require contributors to have signed a Contributor Licence Agreement (CLA).

As GitHub says in its [Terms of Service](https://help.github.com/articles/github-terms-of-service/#6-contributions-under-repository-license), *"Whenever you make a contribution to a repository containing notice of a license, you license your contribution under the same terms, and you agree that you have the right to license your contribution under those terms. [...] This is widely accepted as the norm in the open-source community; it's commonly referred to by the shorthand "inbound=outbound"."*

All submissions are therefore made under the terms and conditions of the widely-used Apache License 2.0 with which this repository is [licensed](LICENSE). In brief, it explains that you must be authorised to submit on behalf of the copyright owner and that you simply grant the project's users, maintainers and contributors the same ability to use your submission as the rest of the repository.

## Joining the AMWA Networked Media Incubator

If you wish to get more involved in creating NMOS specifications, working to implement and improve them, and participating in "plugfests", then your organisation may benefit from joining the [Advanced Media Workflow Association (AMWA)](http://amwa.tv/).

